<?php

/* Admin Options */

$kcr_st_prefix = 'kcr_st_';
define("KCR_ST_PLUGIN_NAME", "KCR Simple Tweet");

function kcr_st_get_options($get_default = false){
	
	$kcr_st_options =  array(
		'kcr_st_twitter_handle' => array('id'=> 'kcr_st_twitter_handle', 'name'=>'Username', 'type'=>'input', 'default'=>'', 'value'=>''),
		'kcr_st_number_tweets' => array('id'=> 'kcr_st_number_tweets', 'name'=>'Number of tweets to display', 'type'=>'input', 'default'=>'5', 'value'=>'5'),
		'kcr_st_time_format' => array('id'=> 'kcr_st_time_format', 'name'=>'Time Format', 'type'=>'input', 'default'=>'Y/m/d H:i:s', 'value'=>'Y/m/d H:i:s'),
		'kcr_st_twitter_consumer_key'=> array('id'=> 'kcr_st_twitter_consumer_key', 'name'=>'Consumer Key', 'type'=>'input', 'default'=>'', 'value'=>''),
		'kcr_st_twitter_consumer_secret'=> array('id'=> 'kcr_st_twitter_consumer_secret', 'name'=>'Consumer Secret', 'type'=>'input', 'default'=>'', 'value'=>''),
		'kcr_st_twitter_oauth_token'=> array('id'=> 'kcr_st_twitter_oauth_token', 'name'=>'Oauth Token', 'type'=>'input', 'default'=>'', 'value'=>''),
		'kcr_st_twitter_oauth_token_secret'=> array('id'=> 'kcr_st_twitter_oauth_token_secret', 'name'=>'Oauth Token Secret', 'type'=>'input', 'default'=>'', 'value'=>''),
		'kcr_st_twitter_include_rts'=> array('id'=> 'kcr_st_twitter_include_rts', 'name'=>'Include Retweets', 'type'=>'yes_no', 'default'=>false, 'value'=>''),
	
	);	
	
	
	if($get_default === true)
		return $kcr_st_options;
			
	$current_options = get_option('kcr_st_options');
	
	if(!is_array($current_options)){
		
		update_option('kcr_st_options', $kcr_st_options);
		
		return $kcr_st_options;
		
	} else
		return $current_options;
		
	
}

function kcr_st_display_options() {
	
	if (!current_user_can('manage_options'))  {
		wp_die( __('You do not have sufficient permissions to access this page.') );
	}

	$update_message = "";
	$available_options = null;
       
    if(count($_POST) > 0){		
		
		if(isset($_POST['action']))
			$action = $_POST['action'];
		else
			$action = false;

		if ( $action == 'save') {
		
			$available_options = kcr_st_get_options();		
		
			foreach($available_options as $id => &$option){
			
				if(isset($_POST[$id])){
				
					$option['value'] = $_POST[$id];
				
				}
			
			}
			
			unset($id, $option);			
			
			if(update_option('kcr_st_options', $available_options))			
				$update_message = 'Settings Updated';				
			else
				$update_message = 'Settings Not Updated';
			
			
		} else if($action == 'reset'){
			
			$available_options = kcr_st_get_options(true);
			
			if(update_option('kcr_st_options', $available_options))			
				$update_message = 'Settings Reset';				
			else
				$update_message = 'Settings Not Reset';
			
		}
		
		unset($available_options);
		
		
		
		
		
	}
	
	
	$available_options = kcr_st_get_options();
	
	if(!empty($update_message))
		echo "<div id='message' class='updated'><p><strong>{$update_message}</strong></p></div>";

	echo "<div class='wrap'>
			<h2>".KCR_ST_PLUGIN_NAME." Settings</h2>

			<form method='post'>
			
				<table width='80%'>";
			
		foreach ($available_options as $option) {

				switch ( $option['type'] ) {

				case 'input':					
				
					echo "<tr>
							<td style='padding: 0 10px;'><strong>{$option['name']}: </strong></td>
							<td><input style='width:600px;' name='{$option['id']}' id='{$option['id']}' type='{$option['type']}' value='{$option['value']}' /></td>
						</tr>";
						
					break;
				
				case 'text':
				

                    echo "<tr>
                              <td style='padding: 0 10px;'><strong>{$option['name']}: </strong></td>
                                <td>";
                                
                                  wp_editor(stripslashes($option['value']), $value['id'], array('media_buttons'=>true, 'textarea_rows'=>10));
                    echo "</td>
                       </tr>";
                       
                 break;
                 
                 case 'yes_no' :
                 
						echo "<tr><td style='padding: 0 10px;'><strong>{$option['name']}: </strong></td><td><select name='{$option['id']}' id='{$option['id']}'><option value='0'>No</option><option value='1' ".($option['value'] == "1" ? " selected='selected' " : "").">Yes</option></select>";
						
						echo "</td></tr>";
                 
                 break;
				
			}
			
		}
		
		echo "<tr>
				<td colspan='2'>
				<p class='submit' style='float:right;'>
						<input name='save' type='submit' value='Save changes' style='font-weight: bold' />
						<input type='hidden' name='action' value='save' />
				</p></form>
				
				<form method='post' id='kcr_reset_options'>
				<p class='submit' style='float:left;'>
						<input name='reset' type='button' value='Reset' onclick='kcr_confirm_reset(\"kcr_reset_options\");' style='background-color: red; background: red url();color:white;text-shadow:none;color:white'/>
						<input type='hidden' name='action' value='reset' />
				</p></form>
			</td></tr>
		</table>
				
	<script type='text/javascript'>
	
	function kcr_confirm_reset(ele){
		
		var confirmed = confirm('Are you sure you want to reset options to default?');
		if(!confirmed) 
			return;
		else
			jQuery('#' + ele).submit();
			
		}</script>";
}

?>
